package com.example.switchyard.switchyard_example;

import java.io.StringReader;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.stream.StreamSource;

import org.switchyard.annotations.Transformer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


public final class MyTransforms {

    @Transformer(to = "{urn:com.example.switchyard:switchyard-example:1.0}processResponse")
    public Element transformWidgetToProcessResponse(Widget widget) {
        StringBuilder ackXml = new StringBuilder()
        .append("<urn:processResponse xmlns:urn=\"urn:com.example.switchyard:switchyard-example:1.0\">")
        .append(    "<widget>")
        .append(        "<processed>" + widget.isProcessed() + "</processed>")
        .append(    "</widget>")
        .append("</urn:processResponse>");
    return toElement(ackXml.toString());
    }

    @Transformer(from = "{urn:com.example.switchyard:switchyard-example:1.0}process")
    public Widget transformProcessToWidget(Element element) {
        Widget widget = new Widget();
        widget.setProcessed(Boolean.valueOf(getElementValue(element, "processed")));
        return widget;
    }

    private String getElementValue(Element parent, String elementName) {
        String value = null;
        NodeList nodes = parent.getElementsByTagName(elementName);
        if (nodes.getLength() > 0) {
            value = nodes.item(0).getChildNodes().item(0).getNodeValue();
        }
        return value;
    }

    private Element toElement(String xml) {
        DOMResult dom = new DOMResult();
        try {
            TransformerFactory.newInstance().newTransformer().transform(new StreamSource(new StringReader(xml)), dom);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ((Document)dom.getNode()).getDocumentElement();
    }

}
