package com.example.switchyard.switchyard_example;

import junit.framework.Assert;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.component.test.mixins.http.HTTPMixIn;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(config = SwitchYardTestCaseConfig.SWITCHYARD_XML, mixins = {HTTPMixIn.class})
public class MyTest {

    @ServiceOperation("MyService.process")
    private Invoker invoker;

    private HTTPMixIn http;

    @Test
    public void testJavaService() {
        Widget widget = new Widget();
        Assert.assertFalse(widget.isProcessed());
        widget = invoker.sendInOut(widget).getContent(Widget.class);
        Assert.assertTrue(widget.isProcessed());
    }

    @Test
    public void testWebService() {
        http.postResourceAndTestXML("http://localhost:18001/switchyard-example/MyService", "/xml/soap-request.xml", "/xml/soap-response.xml");
    }

}
